package mChaRM.mChaRMCollection;

import mChaRM.multichannel.*;
import uka.karmi.rmi.*;

  /**
   * realizes a multi-channel of kind <I>normal</I>. Its meta-behavior does nothing. It can be considered as a default multi-channel.
   * @author  Walter Cazzola (<A HREF="mailto:cazzola@disi.unige.it">cazzola@disi.unige.it</A>)
   * @version 1.1
   * @since Version 1.0
   **/
public class normalChannel extends channelCore implements channelInterface {
    /** 
     * constructor of multi-channels of kind normal.
     * <HR>
     * It calls the {@link mChaRM.multichannel.channelCore#channelCore channelCore} constructor with kind normal and as classes for sender and receiver stubs the default.
     * <HR>
     * @param RsName an Array of Strings representing the name of the receivers, which it is connected to.
     * @exception ReceiverStubNotFoundException thrown when one of the specified receiver wasn't started before the core.
     **/
  public normalChannel(String[] RsName) throws RemoteException, ReceiverStubNotFoundException {
    super("normal", RsName, "mChaRM.multichannel.senderStub", "mChaRM.multichannel.receiverStub");
  }
}  
